/* Definitions of target machine for GNU compiler.
   Motorola 88100 in an 88open ABI environment.
   Copyright (C) 1990 Free Software Foundation, Inc.
   Contributed and currently supported by Tom Wood (wood@dg-rtp.dg.com)

   This is not an official release from FSF.  (The integration of
   these changes is expected to occur in version 2.0.)  Please report
   bugs to wood@dg-rtp.dg.com, not to the mailing lists.  If you are a
   DG customer, please be aware that no support is offered with this
   version and that you should report bugs through official channels.

   The current port of GNU CC to the m88100 is available via anonymous
   ftp to dg-rtp.dg.com.  Please be aware that these sources aren't
   expected to support targets other than the m88100.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define DWARF_DEBUGGING_INFO

#ifndef NO_BUGS
#define AS_BUG_DOT_LABELS
#define AS_BUG_POUND_TYPE
#endif

#include "tm-m88k.h"

/* Identify the compiler.  */
#undef  VERSION_INFO1
#define VERSION_INFO1 "88open ABI, "

/* Default switches */
#undef	TARGET_DEFAULT
#define TARGET_DEFAULT	(MASK_CHECK_ZERO_DIV | \
			 MASK_OCS_DEBUG_INFO | \
			 MASK_SVR4)

/* Linker and library spec's.
   -static, -shared, -symbolic, -h* and -z* access AT&T V.4 link options.
   -svr4 instructs gcc to place /usr/lib/values-X[cat].o on link the line.
   When the -G link option is used (-shared and -symbolic) a final link is
   not being done.  */
#undef	LIB_SPEC
#define LIB_SPEC "%{!shared:%{!symbolic:-lc /usr/ccs/lib/crtn.o}}"
#undef	LINK_SPEC
#define LINK_SPEC "%{z*} %{h*} %{V} %{v:%{!V:-V}} \
		   %{static:-dn -Bstatic} \
		   %{shared:-G -dy} \
		   %{symbolic:-Bsymbolic -G -dy} \
		   %{pg:-L/usr/ccs/lib/libp}%{p:-L/usr/ccs/lib/libp}"
#undef	STARTFILE_SPEC
#define STARTFILE_SPEC "%{!shared:%{!symbolic: \
			 /usr/ccs/lib/crt1.o /usr/ccs/lib/crti.o \
			 %{svr4:%{ansi:/usr/ccs/lib/values-Xc.o} \
			  %{!ansi:%{traditional:/usr/ccs/lib/values-Xt.o} \
			   %{!traditional:/usr/ccs/lib/values-Xa.o}}}}}"

#define ASM_FILE_END(FILE) \
  do { if (write_symbols == DWARF_DEBUG) dwarfout_finalize (); } while (0)

#undef ASM_OUTPUT_DWARF_LINE
#define ASM_OUTPUT_DWARF_LINE(FILE,FILENAME,LINENO) \
  dwarfout_line (FILENAME, LINENO)

#ifdef AS_BUG_POUND_TYPE /* The assembler requires @ rather than #.  */
#undef  FUNCTION_TYPE_ASM_OP
#define FUNCTION_TYPE_ASM_OP	"@function"
#undef  OBJECT_TYPE_ASM_OP
#define OBJECT_TYPE_ASM_OP	"@object"
#endif /* AS_BUG_POUND_TYPE */
