/* Definitions of target machine for GNU compiler.
   Motorola m88100 running Delta88 System V.3.2.
   Copyright (C) 1990 Free Software Foundation, Inc.
   Contributed by Ray Essick (ressick@mot.com)
   Currently supported by Tom Wood (wood@dg-rtp.dg.com)

   This is not an official release from FSF.  (The integration of
   these changes is expected to occur in version 2.0.)  Please report
   bugs to wood@dg-rtp.dg.com, not to the mailing lists.  If you are a
   DG customer, please be aware that no support is offered with this
   version and that you should report bugs through official channels.

   The current port of GNU CC to the m88100 is available via anonymous
   ftp to dg-rtp.dg.com.  Please be aware that these sources aren't
   expected to support targets other than the m88100.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "tm-m88k.h"

/* Default switches */
#undef	TARGET_DEFAULT
#define TARGET_DEFAULT	(MASK_CHECK_ZERO_DIV	| \
			 MASK_OCS_DEBUG_INFO	| \
			 MASK_OCS_FRAME_POSITION)

/* Macros to be automatically defined.  */
#undef	CPP_PREDEFINES
#define CPP_PREDEFINES "-Dm88000 -Dm88k -DsysV88 -D__CLASSIFY_TYPE__=2"

/* Profiled libraries live in a different directory but keep the
   same names other than that.  */
#define LIB_SPEC "%{p:-L/lib/libp}%{pg:%{!p:-L/lib/libp}} -lc"

/*
 * hot version of the profiler that uses r10 to pass the address of
 * the counter.  the _gcc_mcount routine knows not to screw with
 * the parameter registers.
 *
 * DG/UX does this; i wrote a gnu-c/88k specific version and put it
 * in gnulib2.c -- RBE; this macro knows about the leading underscore
 * convention.
 */

#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER(FILE, LABELNO) \
  output_function_profiler (FILE, LABELNO, "_gcc_mcount", 0)

/*
 * Various other changes that we want to have in place without
 * too many changes to the tm-m88k.h file.
 */

#define	USE_LIBG
