#import "RelocManager.h"

typedef struct _Segment {
    pointer_t 		address;
    vm_size_t		size;
    pointer_t		data;
    vm_address_t	maxAddress;
    long		displacement;
    pointer_t		maxData;
    struct {
        unsigned short readIn : 1;
    } rFlags;
    STR segName;
} Segment;

typedef struct _Image {
    STR name;
    struct mach_header *header;
    vm_size_t size;
} Image;

@interface SegmentManager : RelocManager
{
    STR name;
    Image *images;
    int numImages;
}

+newExecutable: (STR)name;
+newCore: (STR)theName;
+newFile: (STR)theName;
-(int)numCommands: (unsigned long)command
        forHeader: (struct mach_header *)header;
-(struct symtab_command *)symCmd;
-(BOOL)isCore;
-(BOOL)isShlib;
-(BOOL)isExecutable;
-(BOOL)validate;

@end

