#import <remote/NXPortPortal.h>

#import <stdlib.h>
#import <string.h>
#import <remote/NXProxy.h>
#import <machkit/LogFunctions.h>
#import <machkit/NXNetNameServer.h>
#import <machkit/exceptions.h>
#import <mach/mach.h>
#import <libc.h>

#import <objc/error.h>
#import <objc/objc-class.h>
#import <objc/objc-runtime.h>
#import <objc/HashTable.h>

#define COMPAT 1

@interface NXPortPortal (Fix)
@end

typedef struct _oold {	// a private data structure
	void		*data;
	unsigned	len;
	
} oold;					/* out-of-line data */

typedef struct {
    msg_header_t	*msg;
	BOOL	freemsgflag;
    BOOL	write;		/* writing vs reading */	//REMOVE AFTER DEBUG!
    id		connection;		// table of ids exported/imported
	NXPort	*port;
	port_t	machPort;
	int		timeout;
    char	*chars;	int		nbchars;	int		maxchars;
    int		*ints;	int		nbints;		int		maxints;
	port_t	*ports;	int		nports;		int		maxports;
	oold	*oolds;	int		noolds;		int		maxoolds;
	
} PSI;			// Port Stream Internal

static void _NXEncodeInt(NXPortPortal *psom, int x) {
	struct _FakePortal { @defs(NXPortPortal) } *fakePortal = psom;
	    
	PSI *stream = (PSI *)fakePortal->_private;
	
    if (stream->nbints + 1 > stream->maxints) {
		stream->maxints += stream->maxints + 1;
		stream->ints = realloc(stream->ints, stream->maxints * sizeof(int));
    }
    stream->ints[stream->nbints++] = x;
}

static void _NXEncodeBool(NXPortPortal *psom, BOOL x) {
    _NXEncodeInt(psom, (x) ? 1 : 0);
}

static void _NXEncodeChars(NXPortPortal *psom, const char *str) {
    _NXEncodeBool(psom, (str) ? YES : NO);
    if (str) {
        unsigned	len = strlen (str);
		_NXEncodeInt(psom, len);
		[psom encodeBytes:str count:len];
    }
}

@implementation NXPortPortal (Fix)

- encodeObject: object {
    BOOL	flag = NO;
	PSI *stream = (PSI *)_private;
	
//	log_info("encodeObject: %x (%s)\n", object, object_getClassName(object));
#if COMPAT
	// XXX first test is compat hook; send old message instead
	if (![object isProxy] && [object respondsTo:@selector(encodeRemotelyFor:freeAfterEncoding:)]) {
//		log_warning("NXPortPortal: class %s should use encodeRemotelyFor:freeAfterEncoding:isBycopy:\n", [object name]);
		object = [object encodeRemotelyFor:stream->connection freeAfterEncoding:&flag];
	}
	else
#endif COMPAT
	object = [object encodeRemotelyFor:stream->connection freeAfterEncoding:&flag isBycopy:NO];
    _NXEncodeBool(self, (object) ? YES : NO);
    if (object) {
		_NXEncodeChars (self, object_getClassName(object));
		[object encodeUsing: self];
		_NXEncodeBool(self, YES);
		if (flag) {
			[object free];
		}
    }
	return self;
}

@end
