#ifndef _MACH_OH_
#define _MACH_OH_

#define TARGET_BYTE_ORDER_BIG_P 1
#include <ansidecl.h>
#include <mach-o/loader.h>
#include "bfd.h"

#define MACH_OH_TEXT_SECT "__TEXT__text"
#define MACH_OH_DATA_SECT "__DATA__data"
#define MACH_OH_BSS_SECT  "__DATA__bss"

typedef struct _mach_oh_ex_data {
  struct _mach_oh_ex_data_flags {
    unsigned short is_shlib : 1;
  } flags;
  asection *textsec;
  asection *datasec;
  asection *bsssec;

  file_ptr sym_filepos;
  unsigned long n_syms;
  file_ptr str_filepos;
  unsigned long str_size;
  
  void *mapped_to;
  unsigned long size;
  
  void *jmp_table_start;
  void *jmp_table_end;
  void *unixThread;
} mach_oh_ex_data;

#define SYMBOL_TABLE_OFFSET(abfd) \
	(((mach_oh_ex_data *)abfd->tdata)->sym_filepos)

#define STRING_TABLE_OFFSET(abfd) \
	(((mach_oh_ex_data *)abfd->tdata)->str_filepos)
#endif /* !_MACH_OH_ */	

bfd *
mach_oh_bfd_from_header(struct mach_header *header, unsigned size);
